/**
 *
 */
package de.intevation.gnv.state;

import org.apache.log4j.Logger;
import org.w3c.dom.Node;

import de.intevation.gnv.artifacts.GNVArtifactBase;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public class StateFactory {

    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger.getLogger(GNVArtifactBase.class);

    private static StateFactory instance = null;

    /**
     * Constructor
     */
    public StateFactory() {
        super();
    }

    public static StateFactory getInstance() {
        if (instance == null) {
            instance = new StateFactory();
        }
        return instance;
    }

    public State createState(Node configuration) {
        log.debug("StateFactory.createState");
        State state = null;
        try {
            String classname = ((org.w3c.dom.Element)configuration).getAttribute("state");
            state = (State) (Class.forName(classname).newInstance());
            state.setup(configuration);
        } catch (InstantiationException e) {
            log.error(e, e);
        } catch (IllegalAccessException e) {
            log.error(e, e);
        } catch (ClassNotFoundException e) {
            log.error(e, e);
        }
        return state;
    }

}
